local ds = require "luci.dispatcher"
local nxo = require "nixio"
local nfs = require "nixio.fs"
local ipc = require "luci.ip"
local sys = require "luci.sys"
local utl = require "luci.util"
local dsp = require "luci.dispatcher"
local uci = require "luci.model.uci"
local lng = require "luci.i18n"
local jsc = require "luci.jsonc"
local http = luci.http
local SYS = require "luci.sys"
local m, s

m = Map("oaf_helper", translate("防沉迷助手(v1.0.1)"),
    translate("防沉迷助手用于在线一键安装防沉迷(OAF)插件"))

s = m:section(TypedSection, "global", translate(""),"")
s.anonymous = true
s:append(Template("oaf_helper"))


-- s = m:section(TypedSection, "ipk", translate("本地安装"), "")

-- fu = s:option(FileUpload, "")
-- fu.template = "cbi/ipk_upload"
-- s.anonymous = true

-- um = s:option(DummyValue, "rule_data")
-- um.template = "cbi/dvalue"
-- um.rawhtml = true


local dir, fd
dir = "/tmp/upload/"
nixio.fs.mkdir(dir)
http.setfilehandler(function(meta, chunk, eof)
    if not fd then
        if not meta then
            return
        end
        if meta and chunk then
            fd = nixio.open(dir .. meta.file, "w")
        end
        if not fd then
            return
        end
    end
    if chunk and fd then
        fd:write(chunk)
    end
    if eof and fd then
        fd:close()
		os.execute("echo ''>/tmp/log/oaf_install.log")
        local ret=os.execute("oaf_mgr install /tmp/upload/"..meta.file..">/dev/null");
	
    	local fd2 = io.open("/tmp/log/oaf_install.log")
		local log_str=""
        if fd2 then
            local line
            while true do
                line = fd2:read("*l")
     		if not line then
                    break
                end
		log_str=log_str.."</br>"..line
	    end
	   fd2:close()
	end	
    if ret == 0 then                                                                                            
		log_str=log_str.."</br><b style='color:green'>install ok</b>"                                       
	else                                                                                                        
		log_str=log_str.."</br><b style='color:red'>install failed</b>"                                     
	end  
	um.value=log_str
    end
end)

if luci.http.formvalue("upload") then
    local f = luci.http.formvalue("ulfile")
    if #f <= 0 then
        -- um.value = translate("No specify upload file.")
    end
elseif luci.http.formvalue("download") then
    Download()
end
return m
